# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "sochdb-kernel"
version = "2.0.4"
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "SochDB Kernel - Minimal ACID core with plugin architecture"
readme = "README.md"
license = "AGPL-3.0-or-later"
resolver = "2"

[features]
default = []
dynamic-plugins = ["libloading"]
wasm-plugins = [
    "wasmtime",
    "toml",
]

[lib]
name = "sochdb_kernel"
path = "src/lib.rs"

[[example]]
name = "01_observability_plugin"
path = "examples/01_observability_plugin.rs"

[[example]]
name = "02_wasm_plugin"
path = "examples/02_wasm_plugin.rs"

[[example]]
name = "03_hot_reload"
path = "examples/03_hot_reload.rs"

[dependencies.bytes]
version = "1.0"

[dependencies.crc32fast]
version = "1.3"

[dependencies.crossbeam-channel]
version = "0.5"

[dependencies.libloading]
version = "0.8"
optional = true

[dependencies.parking_lot]
version = "0.12"

[dependencies.serde]
version = "1.0"
features = ["derive"]
optional = true

[dependencies.sochdb-core]
version = "2.0.4"

[dependencies.thiserror]
version = "1.0"

[dependencies.toml]
version = "0.8"
optional = true

[dependencies.wasmtime]
version = "21"
optional = true

[dev-dependencies.tempfile]
version = "3"

[dev-dependencies.tokio]
version = "1.35"
features = [
    "macros",
    "rt",
]
